{Application 'ENTRY_MENU' logic file generated by CSPro }
PROC GLOBAL 
{ ECUM2012 data entry menu application version - 1.0.0 of 29/12/12 }

  Set explicit;
  { Working variables -- check the lengths needed for all fields }
  FILE      piffile;                    { data entry PFF file for the application }
  FILE      justone;                    { file handler to make sure that there are no concurrent sesions }
  alpha(32) fname, fnameO, fnameN;      { auxiliary filenames for main, Other, and network version of main }
  alpha(26) CSPro;                      { CSPro executables directory }
  alpha(2)  cc;                         { country code }
  alpha(17)  proj;                       { project directory name - keep to 4 letters, e.g. XDHS }
  alpha(8)  app, appmenu, dic;                   { application name and dictionary name }
  alpha(8)  opid;                       { operator ID }
  alpha(2)  floppy, wrkdrv;             { Floppy and workdrive letters, e.g. "A:", "C:" }
  alpha(32) netdrv;                     { Network drive letter, e.g. "N:", or "\\supervisor\share" }
  alpha(32) wrkprj,  xdir, entry, dicts;                  { data entry machine directories }
  alpha(23) data, veri;
  alpha(35) netprj, netdat, netver, netsup, netent, netdic;  { supervisor machine directories }
  alpha(3)  xcluster;                   { Cluster number -- make sure length is correct!!! }
  alpha(4)  fcodes;                     { file codes - C = Main, V = Verification, O = Other, T = Other (Verification) }
  alpha(12) ocodes;                     { Option codes AMT-RUV-NDQ }
  alpha(250) cmdline;                     { Used as a command line or to read strings }
  numeric always, choice, chkok, tmp;
  
  { ---------------------------------------------------------------------------- }
  { function to check presence of network drive}
  function isnet()
    if FileExist( concat( strip(netdrv), "\", strip(proj), "\ECUM2012samp.dat" ) ) then
      tmp = 1;
    else
      tmp = 0;
    endif;
    isnet = tmp;
  end;

  { ---------------------------------------------------------------------------- }
  { Basic file handling functions }

  { checks directories }
  function chkdir();
    if FileExist( xdir ) <> 1 then
{FR} errmsg( "Rpertoire %s n'exist pas",xdir);   {FR}
      stop(-1);
    endif;
  end;

  { Valider les oprations  raliser par l'agent de saisie : }
  { 1-Grappe valide }
  { 2-Pas encore vrifie }
  { 3-Si modification, ne devrait pas tre accept par le superviseur }
  { 4-cluster has been assigned in the control file for either entry or verification }
  { 5-Existence du fichie de donnes conformment  l'opration  executer }
  { 6-A la premire saisie de donnes de la grappe, contrlez s'il n'a pas t saisie ailleurs }
  { 7-Saisie et vrfication ne peuvent tre executes sur la mme machine }
{  function chkexist( addmode, mainver );
    chkok = 0;
    if open( CONTROLE ) then
      { Check if data file cluster is part of the sample }
      if !loadcase( CONTROLE , ECLUSTER ) then
{FR}   errmsg( "*** Grappe numro %s non trouv", {FR}
                xcluster );
      { Check if data file already verified }
      elseif CVERIF then
{FR}   errmsg( "Grappe %s a dj dpass la phase de vrification. Elle ne peut plus tre modifi sur cette machine", {FR}
                xcluster );
      { for addmode, check if data file already passed structure check }
      elseif addmode & mainver = 1 & CMCHECK then
{FR}   errmsg( "Grappe %s dj admise. Elle ne peut pas tre modifie sur cette machine", {FR}
                xcluster );
      { check if cluster has been assigned by supervisor for entry/verification }
      elseif ( (mainver = 1 & CMCRDATE = 0) | (mainver = 2 & CVCRDATE = 0) ) then
{FR}   errmsg( "Grappe %s non encore affecte pour la saisie", {FR}
                xcluster );
      else
        chkok = 1;
      endif;
      close( CONTROLE  );
    endif;
    { check existence of files according to operation to be performed }
    if chkok then
      if mainver = 1 then
        fname  = concat( strip(data), "\", fcodes[mainver  :1], xcluster, ".DAT" );
        fnameO = concat( strip(data), "\", fcodes[mainver+2:1], xcluster, ".DAT" );
      else
        fname  = concat( strip(veri), "\", fcodes[mainver  :1], xcluster, ".DAT" );
        fnameO = concat( strip(veri), "\", fcodes[mainver+2:1], xcluster, ".DAT" );
        endif;
      { Check if data exists for either main/verification }
      if FileExist( fname ) then
        { Check if preciser data exists }
        if !FileExist( fnameO ) then
          { fichier autre  preciser file est manquant }
{FR}     errmsg( "*** Fichier '%s' ne lui est pas associ un fichier '%s' - Prvenez votre superviseur", {FR}
                  fname, fnameO );
          chkok = 0;
        endif;
      { Data does not exist for main/verification. It means that this is the     }
      { first time that the cluster will be entered for either main/verification }
      else
        if addmode then
          { Check if preciser data exists }
          if FileExist( fnameO ) then
{FR}       errmsg( "*** Fichier '%s' a un fichier '%s' qui lui est associ - Prvenez votre superviseur", {FR}
                    strip(fnameO), strip(fname) );
            chkok = 0;
          else
            { since this is the first time that cluster is being entered }
            { check if data is already on the network drive              }
            if mainver = 1 then
              fnameN = concat( strip(netdat), "\", fcodes[mainver:1], xcluster, ".DAT" );
            else
              fnameN = concat( strip(netver), "\", fcodes[mainver:1], xcluster, ".DAT" );
            endif;
            if FileExist( fnameN ) then
{FR}         errmsg( "Grappe %s dj introduite sur une autre machine", {FR}
                      xcluster);
              chkok = 0;
            else { New data }
{FR}         errmsg( "Nouveau fichier '%s'", {FR}
                      strip(fname) );
            endif;
          endif;
        else
{FR}     errmsg( "*** Fichier '%s' n'existe pas  - Utilisez l'option %s", {FR}
                  strip(fname), ocodes[mainver*4-3:1] );
          chkok = 0;
        endif;
      endif;
    endif;
      { For verification, check if main data in the same machine }
    if chkok = 1 & mainver = 2 then
      fname = concat( strip(data), "\", fcodes[1:1], xcluster, ".DAT" );
      if FileExist( fname ) then
{FR}   errmsg( "Grappe %s ne peut pas tre vrifie sur cette machine", {FR}
                xcluster);
        chkok = 0;
      endif;
    endif;
    chkexist = chkok;
  end; }
  
    function chkexist( addmode, mainver );
    chkok = 0;
    if open( CONTROLE ) then
      { Check if data file cluster is part of the sample }
      if !loadcase( CONTROLE , ECLUSTER ) then
{FR}   errmsg( "*** Grappe numro %s non trouv", {FR}
                xcluster );
      { Check if data file already verified }
      else
        chkok = 1;
      endif;
      close( CONTROLE  );
    endif;
    { check existence of files according to operation to be performed }
    if chkok then
      if mainver = 1 then
        fname  = concat( strip(data), "\", fcodes[mainver  :1], xcluster, ".DAT" );
        fnameO = concat( strip(data), "\", fcodes[mainver+2:1], xcluster, ".DAT" );
      else
        fname  = concat( strip(veri), "\", fcodes[mainver  :1], xcluster, ".DAT" );
        fnameO = concat( strip(veri), "\", fcodes[mainver+2:1], xcluster, ".DAT" );
        endif;
      { Check if data exists for either main/verification }
      if FileExist( fname ) then
        { Check if preciser data exists }
        if !FileExist( fnameO ) then
          { fichier autre  preciser file est manquant }
{FR}     errmsg( "*** Fichier '%s' ne lui est pas associ un fichier '%s' - Prvenez votre superviseur", {FR}
                  fname, fnameO );
          chkok = 0;
        endif;
      { Data does not exist for main/verification. It means that this is the     }
      { first time that the cluster will be entered for either main/verification }
      else
        if addmode then
          { Check if preciser data exists }
          if FileExist( fnameO ) then
{FR}       errmsg( "*** Fichier '%s' a un fichier '%s' qui lui est associ - Prvenez votre superviseur", {FR}
                    strip(fnameO), strip(fname) );
            chkok = 0;
          else
            { since this is the first time that cluster is being entered }
            { check if data is already on the network drive              }
            if mainver = 1 then
              fnameN = concat( strip(netdat), "\", fcodes[mainver:1], xcluster, ".DAT" );
            else
              fnameN = concat( strip(netver), "\", fcodes[mainver:1], xcluster, ".DAT" );
            endif;
            if FileExist( fnameN ) then
{FR}         errmsg( "Grappe %s dj introduite sur une autre machine", {FR}
                      xcluster);
              chkok = 0;
            else { New data }
{FR}         errmsg( "Nouveau fichier '%s'", {FR}
                      strip(fname) );
            endif;
          endif;
        else
{FR}     errmsg( "*** Fichier '%s' n'existe pas  - Utilisez l'option %s", {FR}
                  strip(fname), ocodes[mainver*4-3:1] );
          chkok = 0;
        endif;
      endif;
    endif;
      { For verification, check if main data in the same machine }
    if chkok = 1 & mainver = 2 then
      fname = concat( strip(data), "\", fcodes[1:1], xcluster, ".DAT" );
      if FileExist( fname ) then
{FR}   errmsg( "Grappe %s ne peut pas tre vrifie sur cette machine", {FR}
                xcluster);
        chkok = 0;
      endif;
    endif;
    { For main version, check if veri data in the same machine }
    {if chkok = 1 & mainver = 1 then
      fname = concat( strip(veri), "\", fcodes[2:1], xcluster, ".DAT" );
      if FileExist( fname ) then
{FR}   errmsg( "Grappe %s ne peut pas tre traite en saisie principale sur cette machine", {FR}
                xcluster);
        chkok = 0;
      endif;
    endif;}
    chkexist = chkok;
  end;

  { after a data entry session is finished, transfer files to the server }
  function backupf( mainver );
    if wrkdrv <> netdrv then
     if isnet() then { still connected to network }
      if FileExist( netprj ) then        { still connected to network }
        fname = concat( fcodes[mainver:1], xcluster, ".dat" );
        if mainver = 1 then
          FileCopy( concat(strip(data), "\", strip(fname) ), concat(strip(netdat), "\", strip(fname)) );
          FileDelete( concat(strip(netdat), "\", strip(fname), ".idx") );   { Delete index files - if they exist }
          fname = concat( fcodes[mainver+2:1], xcluster, ".dat" );
          FileCopy( concat(strip(data), "\", strip(fname)), concat(strip(netdat), "\", strip(fname)) );
          FileDelete( concat(strip(netdat), "\", strip(fname), ".idx") );   { Delete index files - if they exist }
        else
          FileCopy( concat(strip(veri), "\", strip(fname)), concat(strip(netver),"\", strip(fname)) );
          { index file is required for verification purposes }
          fname = concat( fcodes[mainver:1], xcluster, ".dat.idx" );
          FileCopy( concat(strip(veri), "\", strip(fname)), concat(strip(netver),"\", strip(fname)) );
          { No need to copy the "preciser" file as it is always empty for verification }
        endif;
      else
      { Computer was disconnected from the network }
{FR}   errmsg( "!!! ALERTE Ordinateur dconnect du rseau, vrifiez avec votre SUPERVISEUR" ); {FR}
{FR}   errmsg( concat( "Utilisez l'option %s pour transfrer les donnes principales en utilisant des cls USB\n",
                        "ou l'option %s pour transfrer les donnes de vrification en utilisant des cls USB", ocodes[3:1], ocodes[7:1] ));
      endif;
    endif;
    endif;
  end;

  { creates a PFF file for data entry }
  function genpff( addmode, mainver );
    setfile( piffile, concat( strip(entry), "\", strip(app), ".pff" ) );
    FileDelete( piffile );
    FileWrite( piffile, "[Run Information]" );
    FileWrite( piffile, "Version=CSPro 4.1" );
    FileWrite( piffile, "AppType=Entry" );

    FileWrite( piffile, "[DataEntryInit]" );
    FileWrite( piffile, concat( "OperatorID=", strip(opid) ) );
    if addmode then
      FileWrite( piffile, "StartMode=ADD" );
      FileWrite( piffile, "Lock=Modify, Verify" );
      FileWrite( piffile, "Fullscreen=Yes" );
    else
      { no StartMode for modify }
      FileWrite( piffile, "Lock=Add, Verify" );
    endif;
    FileWrite( piffile, "NoFileOpen=Yes" );

    FileWrite( piffile, "[Files]" );
    FileWrite( piffile, concat( "Application=", strip(entry), "\", strip(app), ".ent" ) );
    if mainver = 1 then
      FileWrite( piffile, concat( "InputData=", strip(data), "\", fcodes[mainver:1], xcluster, ".DAT" ) );
    else 
      FileWrite( piffile, concat( "InputData=", strip(veri), "\", fcodes[mainver:1], xcluster, ".DAT" ) );
    endif;

    FileWrite( piffile, "[ExternalFiles]" );
    {FileWrite( piffile, concat( cc, "SAMP=", strip(wrkprj), "\", cc, "SAMP.DAT" ) );}
    if mainver = 1 then
      FileWrite( piffile, concat("PRECISER_DICT=", strip(data), "\", fcodes[mainver+2:1], xcluster, ".DAT" ) );
    else
      FileWrite( piffile, concat("PRECISER_DICT=", strip(veri), "\", fcodes[mainver+2:1], xcluster, ".DAT" ) );
    endif;

    FileWrite( piffile, "[Parameters]" );
    FileWrite( piffile, concat( "Parameter=", xcluster ) );
    close( piffile );
  end;

  { calls CSEntry to run the data entry application }
  function runpff();
    { Using single quotes instad of double quotes as double quotes are needed in the string generated }
    ExecSystem( concat( '"', strip(cspro), '\CSEntry.exe" ',
                             strip(entry), "\", strip(app), '.pff' ), maximized, wait );
  end;

  { call major functions to:                       }
  { 1-verify that the operation requested is valid }
  { 2-generate PFF file for the application        }
  { 3-run data entry module and                    }
  { 4-transfer data to the server                  }
  function csrun( addmode, mainver );
    if chkexist( addmode, mainver ) then
      genpff( addmode, mainver );
      runpff();
      backupf( mainver );
    endif;
  end;

  { copy data to diskette to transfer to supervisor machine }
  { to be used when a network is not available              }
  function transfer( mainver );
{FR} errmsg( "*** Insrez la cl USB de donnes dans le lecteur %s", floppy ); {FR}
    if chkexist( 0, mainver ) then
      fnameN = concat( strip(floppy), "\", fcodes[mainver:1], xcluster, ".dat" );
      if FileExist( fnameN ) then
{FR}   errmsg( "*** Grappe %s existe dj dans le lecteur %s -- Veuillez vous en assurer", xcluster, floppy ); {FR}
      endif;
      fname = concat( fcodes[mainver:1], xcluster, ".dat" );
      FileCopy( concat(strip(data), "\", fname), concat(floppy, "\", fname) );
      fname = concat( fcodes[mainver:1], xcluster, ".dat" );
      FileCopy( concat(strip(data), "\", fname), concat(floppy, "\", fname) );
{FR} errmsg( "Copie des fichiers de donnes de la grappe %s  une disquette", xcluster ); {FR}
    endif;
  end;

  { Copy all files needed in the client from the server to execute data entry }
  { FileCopy doesn't accept wild chracteres, so the file names need to be fully specified }
  function CopyFromServer();
    { copy CONTROLE file from supervisor machine       }
    FileCopy( concat(strip(netprj), "\CONTROLE.DAT"), concat(strip(wrkprj), "\CONTROLE.DAT") );
   
    { !!!! make sure that sample file has the name ENPSAMP for country cc }
    FileCopy( concat(strip(netprj), "\", strip(cc), "ECUM2012SAMP.DAT"), concat(strip(wrkprj), "\", strip(cc), "ECUM2012SAMP.DAT") );
    { copy all dictionaries from DICTS directory }
    FileCopy( concat(strip(netdic), "\", strip(dic), ".dcf"), concat(strip(dicts), "\", strip(dic), ".dcf"));
    { copies files related to the data entry application }
    FileCopy( concat(strip(netent), "\", strip(app), ".ent.app"), concat(strip(entry), "\", strip(app), ".ent.app") );
    FileCopy( concat(strip(netent), "\", strip(app), ".ent"), concat(strip(entry), "\", strip(app), ".ent") );
    FileCopy( concat(strip(netent), "\", strip(app), ".ent.qsf"), concat(strip(entry), "\", strip(app), ".ent.qsf") );
    FileCopy( concat(strip(netent), "\", strip(app), ".ent.mgf"), concat(strip(entry), "\", strip(app), ".ent.mgf") );
    { copies files related to the data menu application }
    FileCopy( concat(strip(netent), "\", strip(appmenu), ".ent.app"), concat(strip(entry), "\", strip(appmenu), ".ent.app") );
    { copies main dictionary and preciser form files }
    FileCopy( concat(strip(netent), "\", strip(dic), ".fmf"), concat(strip(entry), "\", strip(dic), ".fmf") );
    FileCopy( concat(strip(netent), "\preciser.fmf"), concat(strip(entry), "\preciser.fmf") );
 end;
 
PROC ENTRY_MENU_FF

Preproc

  CSPro = "C:\Program Files\CSPro 4.1";
  cc = "";
  app = "ECUM2012";
  appmenu = "ENTRY_MENU";
  dic = "ECUM2012";
  opid = "ECUM2012";                { this could be an ID set on each machine }
  floppy = "F:";
  { File codes - S = Saisie, V = Vrification, A = Autre, P = Prciser (Vrification) }
  fcodes = "SVAP";
  ocodes = "AMT-RUV-NDQ";

  { Set work drive }
  wrkdrv = "C:";
  { Project directory (use 4 characters) }
  proj = "ECUM2012\MASQUE";
  wrkprj = concat( strip(wrkdrv), "\", proj );

  { These directories should be present in the data entry machine      }
  { \ECUM2012              Main survey directory (some files located here) }
  { \ECUM2012\ENTRY        Data entry programs located here                }
  { \ECUM2012\DICTS        Directory used to store dictionaries            }
  { \ECUM2012\DATA         Directory used to store main data               }
  { \ECUM2012\VERI         Directory used to store verification data       }
  entry = concat( strip(wrkprj), "\ENTRY" );
  dicts = concat( strip(wrkprj), "\DICTS" );
  data  = concat( strip(wrkprj), "\DATA" );
  veri  = concat( strip(wrkprj), "\VERI" );

  { Check that data entry directories needed exist }
  xdir = wrkprj; chkdir();
  xdir = entry;  chkdir();
  xdir = dicts;  chkdir();
  xdir = data;   chkdir();
  xdir = veri;   chkdir();

  { Set network drive letter }
  netdrv="\\supervisor";     
 { netdrv = "J:"; }
  { Alternatively the following form can be used }
  { netdrv="\\supervisorcomputer\sharename";     }
  { if no network, use local directories         }
  if isnet() then
    errmsg("Connect au Rseau ");
  else
    errmsg("Warning : Rseau %s non trouv", strip(netdrv));
    netdrv = wrkdrv;
  endif;

  { Set network drive directories }
  netprj = concat( strip(netdrv), "\", strip(proj) );
  netent = concat( strip(netprj), "\ENTRY" );
  netdic = concat( strip(netprj), "\DICTS" );
  netdat = concat( strip(netprj), "\DATA" );
  netver = concat( strip(netprj), "\VERI" );
  netsup = concat( strip(netprj), "\SUPERV" );

  {netwrk = concat(strip(netprj), "\WORK" );}
  
  { Copy network programs and data to client machine }
  if strip(netdrv) <> strip(wrkdrv) then
    CopyFromServer();
   endif;

  { Check that there are not two concurrent sessions of CSPro loaded at the same time }
  SetFile( justone, concat( strip(entry), "\justone.txt" ) );
  if FileExist( justone ) then
    FileRead( justone, cmdline );
    errmsg( "*** %s", strip(cmdline) );
    if accept(
{FR}         "Re-initialiser","Oui","Non" {FR}
             ) = 1 then
      FileDelete( justone )
    else
      stop(-1);
    endif;
  endif;

  FileWrite( justone,
{FR}        "Il y a une autre session en cours ou bien que l'ordinateur s'est plant en cours d'excution" {FR}
           );
  close( justone );
PROC ECLUSTER
 xcluster = edit( "999", $ );
  if !loadcase( CONTROLE, ECLUSTER) then
      errmsg(" Loadcase %02d", !loadcase( CONTROLE, ECLUSTER ));
{FR} errmsg( "*** Grappe numro %s non trouve", {FR}
                xcluster );
    reenter;
  endif;
  always = 1;
  while always do   { loop forever }
    { Get the selected option }
{FR}
    choice = accept( "Options du menu de saisie de donnes",
                     "A  Ajouter de nouvelles donnes au fichier.....A",
                     "M  Modifier le fichier de donnes..............M",
                     "T  Transfrer les donnes de saisie ...........T",
                     "------------------------------------------------",
                     "R  Re-saisir les donnes pour la vrification..R",
                     "U  Modifier les donnes de vrification........U",
                     "V  Transfrer le fichier de vrification.......V",
                     "------------------------------------------------",
                     "N  Nouveau numro de grappe....................N",
                     "Q  Quitter.....................................Q" );
{FR}
    if choice     =  0 then {ESC} reenter; { escape from menu & allow entry of new cluster number }
    elseif choice =  1 then {ADD} csrun( 1, 1 ); {Main}
    elseif choice =  2 then {MOD} csrun( 0, 1 ); {Main}
    elseif choice =  3 then Transfer( 1 );                {Main}
    elseif choice =  4 then {---} { do nothing }
    elseif choice =  5 then {ADD} csrun( 1, 2 ); {Verification}
    elseif choice =  6 then {MOD} csrun( 0, 2 ); {Verification}
    elseif choice =  7 then Transfer( 2 );                {Verification}
    elseif choice =  8 then {---} { do nothing }
    elseif choice =  9 then {NEW} reenter; { get the new cluster number }
    elseif choice = 10 then {QUIT}
      fname = concat( strip(wrkprj), "\justone.txt" );
      if FileExist( justone ) then
        FileDelete( justone )
      endif;
      stop(-1);       { quit the process }
    endif;
  enddo;
