{Application 'SUPERV_MENU' logic file generated by CSPro }
PROC GLOBAL 

{ ENP2011 Menu superviseur version 1.0.1  16/09/2011 }

 Set explicit;

  { Working variables -- check the lengths needed for all fields }
  FILE      piffile;                    { file handler to construct PFF files for all applications }
  FILE      diffile;                    { file handler to manipulate differences between main & verified files }
  FILE      justone;                    { file handler to make sure that there are no concurrent sesions }
  alpha(26) CSPro;                      { CSPro executables directory }
  alpha(2)  cc;                         { country code }
  alpha(15)  proj;                      { project directory name - keep to 4 letters, e.g. XDHS }
  alpha(8)  app, dic, entapp, tab, ckid, editing, centry, statrep, compar, expor;  { application name and dictionary name }
  array alpha(8) appt(3);                 { type of application: 1=Entry, 2=Batch, 3=Compare, }
  array alpha(8) appx(3);                 { executable name }
  array alpha(8) appext(3);               { application extension }
  alpha(8)  wrkdrv;                       { work drive may include the root directory shared by other machines }
  alpha(2)  bkpdrv;                       { work drive may also include the root directory }
  alpha(8)  floppy;                       { Floppy drive letters, e.g. "A:", "C:", "D:" }
  alpha(35) wrkprj, supdir, repdir, bkpdir, wrkdir, verdir, rawdir, findir; { directories }
  alpha(32) entdir, dicdir;               { directory names for ENTRY, DICTS -- suggest using these names }
  alpha(35) wdir, xdir;                   { Working directory fields }
  alpha(45) fname;                        { filenames for various files }
  alpha(40) textname;                     { filename for files to be shown by textview }
  alpha(250) cmdline;                     { Used as a command line or to read strings }
  alpha(3)  xcluster;                     { Cluster number -- make sure length is correct!!! }
  alpha(4)  fcodes;                       { file codes - C = Main, V = Verification, O = Other, T = Other (Verification) }
  alpha(4)  suff;                         { Suffix between app name and extension }
  alpha(32) bkpdest;                      { used by the backup routine to tell where to copy to }
  numeric always, choice, ret, run1, verified;
  numeric entry, batch, diff, main, verif, others , msg, nomsg, endfile, x; { Constants }

  { ---------------------------------------------------------------------------- }

  { Contrle que les repertoires ncessaires sont disponibles }
  function chkdir()
    if FileExist( xdir ) <> 1 then
  {FR} errmsg( "*** Rpertoire %s n'existe pas", xdir );   {FR}
      stop(-1);
    endif;
  end;

  { Contrle que le repertoire de donnes et de verification existent }
  function chkexist( mainver, xmsg );
    { Contrle existence fichier de donnes }
    fname  = concat( strip(wdir), "\", fcodes[mainver:1], xcluster, ".DAT" );
    { Contrle existence repertoire de donnes }
    if FileExist( fname ) <> 1 then
      if xmsg then        { Afficher le message }
  {FR} errmsg("*** Fichier '%s' n'exist pas", {FR}
               strip(fname));
      endif;
      chkexist = 0;
    else
      chkexist = 1;
    endif;
  end;

  { ---------------------------------------------------------------------------- }

  { Bote de dialogue pour confirmer la copie des fichiers }
  function backup();
    backup = ( accept(
  {FR}                "Est-ce que vous voulez copier ce fichier", "Oui", "Non" {FR}
              ) = 1 {Oui seulement, pas Non ou Echap} );
  end;

  { T/U: Transferer donnes/verification de la disquette }
  function transfer( mainver )
  {FR} errmsg( "... Insrez la cl USB de donnes dans le lecteur %s", floppy ); {FR}
    wdir = floppy;
    if chkexist( mainver, msg ) then     { Fichier existe dans la cl }
      if mainver = 1 then
        wdir = bkpdir;
      else
        wdir = verdir;
      endif;
      if chkexist( mainver, nomsg ) then
  {FR} errmsg( "*** Grappe %s existe dj dans le lecteur %s -- Veuillez vous en assurer", xcluster, wdir ); {FR}
      endif;
      if backup() then
        fname = concat( fcodes[mainver:1], xcluster, ".dat " );
        FileCopy( concat(strip(floppy), "\", fname), concat(wdir, "\", fname) );
        FileDelete( concat(strip(wdir), "\", fname, ".idx ") );   { Dtruire ancien fichier index -- s'il existe }
        fname = concat( fcodes[mainver+2:1], xcluster, "s.dat " );
        FileCopy( concat(strip(floppy), "\", fname), concat(wdir, "\", fname) );
        FileDelete( concat(strip(wdir), "\", fname, ".idx ") );   { Dtruire ancien fichier index -- s'il existe }
  {FR} errmsg( "... Copie des fichiers de donnes de la grappe %s  partir de la cl USB", xcluster ); {FR}
      endif;
    endif;
  end;

  { ---------------------------------------------------------------------------- }

  { Generer un .PFF file pour l'application }
  function genpff( apptype, addmode )
    xdir = supdir; if apptype = Entry & app = entapp then xdir = entdir endif;
    suff = "";     if apptype > Batch then suff = appext(apptype) endif;     { suffix, e.g. .cmp, needed before .pff }
    SetFile( piffile, concat(strip(xdir), "\", strip(app), strip(suff), ".pff") );
    FileDelete( piffile );
    { Run information section }
    FileWrite( piffile, "[Run Information]" );
    FileWrite( piffile, "Version=CSPro 4.1" );
    FileWrite( piffile, concat( "AppType=", strip(appt(apptype)) ) );

    { Data Entry Init section - data entry only }
    if apptype = Entry then
      FileWrite( piffile, " " );
      FileWrite( piffile, "[DataEntryInit]" );
      FileWrite( piffile, "OperatorID=Superv" );
      if addmode then
        FileWrite( piffile, "StartMode=ADD" );
        FileWrite( piffile, "Lock=Modify,Verify" );
        FileWrite( piffile, "Fullscreen=Yes" );
      else
        { no StartMode for modify }
        FileWrite( piffile, "Lock=Add,Verify" );
      endif;
      FileWrite( piffile, "NoFileOpen=Yes" );
    endif;

    { Files section }
    FileWrite( piffile, " " );
    FileWrite( piffile, "[Files]" );
    FileWrite( piffile, concat( "Application=", strip(xdir), "\", strip(app), strip(appext(apptype)) ) );
    if app = statrep then
      FileWrite( piffile, concat("InputData=", strip(wrkprj), "\CONTROLE.dat") );
    elseif app = centry then
      FileWrite( piffile, "InputData=CNULL.dat" );
     elseif app = tab then
      FileWrite( piffile, concat( "InputData=", strip(repdir), "\", strip(dic), ".DAT" ) );
    else
      FileWrite( piffile, concat( "InputData=", strip(wdir), "\", fcodes[main:1], xcluster, ".DAT" ) );
    endif;
    FileWrite( piffile, concat( "Listing=", strip(xdir), "\", strip(app), ".lst" ) );
    if apptype = Batch & app <> editing then       { Ecrire le resultat dans le fichier listing .lst pour dition }
      FileWrite( piffile, concat( "WriteData=", strip(xdir), "\", strip(app), ".wrt" ) );
    elseif apptype = Diff then
      FileWrite( piffile, concat( "ReferenceData=", strip(verdir), "\", fcodes[verif:1], xcluster, ".DAT" ) );
    endif;

    { External Files section }
    FileWrite( piffile, " " );
    FileWrite( piffile, "[ExternalFiles]" );
    if apptype = Entry then
      if app = centry then
        FileWrite( piffile, concat("CONTROLE=", strip(wrkprj), "\Controle.dat") );
       elseif app = entapp then
        { FileWrite( piffile, concat( cc, "SAMP=", strip(wrkprj), "\", cc, "CSAMP.DAT" ) );}
        FileWrite( piffile, concat( "PRECISER_DICT=", strip(wrkdir), "\", fcodes[others:1], xcluster, ".DAT" ) );
      endif;
    elseif apptype = Batch then
      FileWrite( piffile, concat("CONTROLE=", strip(wrkprj), "\Controle.dat") );
    endif;

    { Parameters section }
    FileWrite( piffile, " " );
    FileWrite( piffile, "[Parameters]" );
    FileWrite( piffile, concat( "Parameter=", xcluster ) );
    FileWrite( piffile, "ViewListing=Never" );     { Do not show .lst -- will be shown manually }
    FileWrite( piffile, "ViewResults=No" );        { Do not show .wrt -- will be shown manually }
    close( piffile );
  end;

  { Runs a .PFF for an application }
  function runpff( apptype );
    { Using single quotes instead of double quotes as double quotes are needed in the string generated }
    ExecSystem( concat('"', strip(cspro), '\', strip(appx(apptype)), '.exe" ',
                            strip(xdir), "\", strip(app), strip(suff), '.pff'), wait );
  end;

  { Views a text file }
  function textview();
    { Using single quotes instead of double quotes as double quotes are needed in the string generated }
    ExecSystem( concat('"', strip(cspro), '\TextView.exe" ', textname), wait );
  end;

  { ---------------------------------------------------------------------------- }

  { L: Lister les questionnaires d'une grappe }
  function op_LST();
    ret = 0;
    if !chkexist( main, msg ) then { Message already displayed }
    else
      app = ckid;
      genpff( Batch, 0 );
      runpff( Batch );
      { Merge .lst and .wrt files into .IDS file and display it }
      textname = concat( strip(repdir), "\", fcodes[main:1], xcluster, ".IDS" );
      FileConcat( textname, concat(strip(supdir), "\", strip(app), ".lst"),
                            concat(strip(supdir), "\", strip(app), ".wrt") );
      textview();
      if !loadcase( CONTROLE, ECLUSTER ) then
  {FR} errmsg( "*** Grappe numro %s non trouv", {FR}
                xcluster );
      elseif cmcheck = 0 then
      { Check structure check OK (CMCHECK) }
  {FR} errmsg( "*** Contrle de structure montre des problmes dans les donnes" ); {FR}
      else
        { structure check OK }
        ret = 1;
      endif;
    endif;
    op_LST = ret;
  end;

  { A: Accepter grappe }
  function op_ACC();
    wdir = bkpdir;        { different directory used than wrkdir }
    { Check main data entry assigned (CMCRDATE) }
    if cmcrdate = 0 then
  {FR} errmsg( "*** Grappe %s non encore affecte  la saisie", {FR}
                xcluster );
    elseif !chkexist( main, msg ) then { Message already displayed }
    elseif crawdate <> 0 then
      { Check Raw data backup done (CRAWDATE) }
  {FR} errmsg( "*** Donnes brutes du fichier %s%s.DAT' existe dj: date=%d", {FR}
                fcodes[1:1], xcluster, crawdate );
    elseif !op_LST() then { Message already displyed }
    elseif backup() then
  {FR} errmsg( "... Copie du fichier de donnes dans le rpertoire de travail %s", wrkdir ); {FR}
      fname = concat( fcodes[main:1], xcluster, ".DAT" );
      FileCopy( concat(strip(bkpdir), "\", fname), concat(strip(wrkdir), "\", fname) );
      FileDelete( concat( strip(wrkdir), "\", fname, ".idx" ) );  { Delete old index files -- if they exist }
      fname = concat( fcodes[others:1], xcluster, ".DAT" );
      FileCopy( concat(strip(bkpdir), "\", fname), concat(strip(wrkdir), "\", fname) );
      FileDelete( concat( strip(wrkdir), "\", fname, ".idx" ) );  { Delete old index files -- if they exist }
  {FR} errmsg( "... Grappe %s accepte", {FR}
                xcluster );
      ret = 1;
    endif;
  end;

  { ---------------------------------------------------------------------------- }

  function nodiff( alpha(255) differences );
    SetFile( diffile, differences );
    endfile = 0;
    { also using cmdline as a string var to read the file into }
    while !endfile do
      x = FileRead( diffile,  cmdline );
      if x < 1 then                          { end of file found }
         endfile = 2;
      elseif pos( "[", cmdline ) then        { Found the start of an ID string - means there must be some differences }
         endfile = 1;
      endif;
    enddo;
    close( diffile );
    nodiff = ( endfile =  2 );
  end;

  { V: Verify double entered questionnaires }
  function op_VER();
    { Check verification done (CVERIF) }
    if cverif <> 0 then
  {FR} errmsg( "*** Vrification des questionnaires dj effectue" ); {FR}
    elseif cvcrdate = 0 then
  {FR} errmsg( "*** Grappe non encore assigne pour la verificacion" ); {FR}
    elseif cmcheck = 0 then
  {FR} errmsg( "*** Contrle de structure non termin" ); {FR}
    else
      wdir = verdir;
      if !chkexist( verif, msg ) then { Message already displayed }
      else
        wdir = wrkdir;
        if !chkexist( main, msg ) then { Message already displayed }
        else
          app = compar;
          genpff( Diff, 0 );
          runpff( Diff );

          textname = concat( strip(repdir), "\", fcodes[main:1], xcluster, ".DIF" );
          FileCopy( concat(strip(supdir), "\", strip(app), ".LST"), textname );

          verified = nodiff( textname );
          if verified then
  {FR}     errmsg( "Aucune diffrence n'est trouve" ); {FR}
          else
            textview();
          endif;

          { Update verification date }
          if !loadcase( CONTROLE, ECLUSTER ) then
  {FR}     errmsg( "*** Grappe numro %s non trouve", {FR}
                    xcluster );
          else
            if verified then
              cverif = sysdate();
            else
              cverif = 0;
            endif;
            if !writecase( CONTROLE, ECLUSTER ) then
  {FR}       errmsg( "*** Modification du fichier de contrle pour la grappe %s pas possible", {FR}
                      xcluster );
            endif;
          endif;
        endif;
      endif;
    endif;
  end;

  { K: Keep original raw data before editing }
  function op_KEE();
    { Check verification done (CVERIF) }
    if cverif = 0 then
  {FR} errmsg( "*** Vrification des questionnaires non encore effectue" ); {FR}
    else
      wdir = rawdir;
      if chkexist( main, nomsg ) then
  {FR} errmsg( "*** Donnes brutes du fichier %s%s.DAT' existe dj ", {FR}
                fcodes[main:1], xcluster );
      endif;
      wdir = wrkdir;
      if !op_LST() then { Message already displayed }
      elseif backup() then
  {FR} errmsg( "... Copie du fichier de donnes de travail au fichier de donnes brutes sur %s ", {FR}
                strip(rawdir));
        fname = concat( fcodes[main:1], xcluster, ".DAT" );
        FileCopy( concat(strip(wrkdir), "\", fname), concat(strip(rawdir), "\", fname) );
        fname = concat( fcodes[others:1], xcluster, ".DAT" );
        FileCopy( concat(strip(wrkdir), "\", fname), concat(strip(rawdir), "\", fname) );
        wdir = rawdir;
        if chkexist( main, msg ) then
          { Update raw data backup done }
          if !loadcase( CONTROLE, ECLUSTER ) then
  {FR}     errmsg( "*** Grappe numro %s non trouve ", {FR}
                    xcluster );
          else
            crawdate = sysdate();
            if !writecase( CONTROLE, ECLUSTER ) then
  {FR}       errmsg( "*** Modification du fichier de contrle pour la grappe %s pas possible ", {FR}
                      xcluster );
            else
  {FR}       errmsg( "*** Grappe %s copie ",  {FR}
                      xcluster );
            endif;
          endif;
        endif;
      endif;
    endif;
  end;

  { ---------------------------------------------------------------------------- }

  { G: Generate error listing (secondary editing) }
  function op_GEN();
    { Check raw data backup done (CRAWDATE) }
    if crawdate = 0 then
  {FR} errmsg( "*** Sauvegarde du fichier de donnes brutes non encore faite "); {FR}
    elseif chkexist( main, msg ) then { Message already displayed }
      filecopy(concat(strip(wrkprj),"\","CONTROLE.DAT.IDX"),concat(strip(wrkprj),"\","CONTROLE1.DAT.IDX"));
      run1 = ( cedit(1) = 0 );
      app = editing;
      genpff( Batch, 0 );
      runpff( Batch );

      textname = concat( strip(repdir), "\", fcodes[main:1], xcluster, ".REP" );
      FileCopy( concat(strip(supdir), "\", strip(app), ".lst"), textname );
      if run1 then
        filecopy(strip(textname), concat(textname[1:length(strip(textname))+4], ".1"));
      endif;
      textview();
      filecopy(concat(strip(wrkprj),"\","CONTROLE.DAT.IDX"),concat(strip(wrkprj),"\","CONTROLE.DAT.IDX"));
      filedelete(concat(strip(wrkprj),"\","CONTROLE.DAT.IDX"));
      if accept("Cas d'apurement ?", "Oui", "Non") = 1 then
       if cedit(3) <> 0 and cedit(4) = 0 then cedit(4) = sysdate(); endif; 
       if cedit(2) <> 0 and cedit(3) = 0 then cedit(3) = sysdate(); endif;
       if cedit(1) <> 0 and cedit(2) = 0 then cedit(2) = sysdate(); endif;       
       if cedit(1) = 0 then cedit(1) = sysdate(); endif;
      endif;
      writecase(CONTROLE,ecluster);
    endif;
  end;

  { M: Modify data (secondary editing) }
  function op_MOD();
    wdir = wrkdir;
    { Check raw data backup done (CRAWDATE) }
    if crawdate = 0 then
  {FR} errmsg( "*** Sauvegarde du fichier de donnes brutes non encore faite" ); {FR}
    elseif !chkexist( main  , msg ) then { Message already displayed }
    elseif !chkexist( others, msg ) then { Message already displayed }
    else
      app = entapp;
      genpff( Entry, 0 );  { 0=Modify mode }
      runpff( Entry );
    endif;
  end;

  { S: Save final raw data after editing }
  function op_SAV();
    { Check at least one edit run done (CEDIT) }
    { cluster has to be reloaded in case it has just passed through secondary editing }
    if !loadcase( CONTROLE, ECLUSTER ) | cedit(1) = 0 then
  {FR} errmsg( "*** Edition secondaire des questionnaires non encore faite" ); {FR}
    else
      wdir = findir;
      if chkexist( main, nomsg ) then
  {FR} errmsg( "*** Donnes finales du fichier %s%s.DAT' existe dj ", {FR}
                fcodes[main:1], xcluster );
      endif;
      wdir = wrkdir;
      if !op_LST() then { Message already displayed }
      elseif backup() then
  {FR} errmsg( "... Copie du fichier de donnes de travail au fichier de donnes finales sur %s ",{FR}
                strip(findir) );
        fname = concat( fcodes[main:1], xcluster, ".DAT" );
        FileCopy( concat(strip(wrkdir), "\", fname), concat(strip(findir), "\", fname) );
        fname = concat( fcodes[others:1], xcluster, ".DAT" );
        FileCopy( concat(strip(wrkdir), "\", fname), concat(strip(findir), "\", fname) );
        wdir = findir;
        if chkexist( main, msg ) then
          { Update final data backup done }
          if !loadcase( CONTROLE, ECLUSTER ) then
  {FR}     errmsg( "*** Grappe numro %s non trouve ", {FR}
                    xcluster );
          else
            cfindate = sysdate();
            if !writecase( CONTROLE, ECLUSTER ) then
  {FR}       errmsg( "*** Modification du fichier de contrle pour la grappe %s pas possible ", {FR}
                      xcluster );
            else
  {FR}       errmsg( "*** Grappe %s sauvegarde ", {FR}
                      xcluster );
            endif;
          endif;
        endif;
      endif;
    endif;
  end;

  { ---------------------------------------------------------------------------- }

  { C: Mise a jour fichier CONTROLE }
  function op_QCT();
    app = centry;
    genpff( Entry, 1 );  { 1= Mode ajout }
    runpff( Entry );
    { Copier controle.dat dans le repertoire back }
    FileCopy( concat(strip(wrkprj), "\Controle.dat"), concat(strip(bkpdir), "\controle.dat") );
    
  end;

  { R: Report data processing status }
  function op_CST();
    app = statrep;
    genpff( Batch, 0 );
    runpff( Batch );
    textname = concat(strip(supdir), "\", strip(app),".WRT");
    textview();
  end;

  { ---------------------------------------------------------------------------- }

  { F: Executer exportation donnees }
  
  function gen_EXPORT();
  
    SetFile( piffile, concat(strip(wrkdrv),"\",strip(proj), "\", strip(expor),"\", strip(expor), ".pff") );
    FileDelete( piffile );
    { Run information section }
    FileWrite( piffile, "[Run Information]" );
    FileWrite( piffile, "Version=CSPro 4.1" );
    FileWrite( piffile, concat( "AppType=", strip(appt(2)) ) );
    
   { Files section }
    FileWrite( piffile, " " );
    FileWrite( piffile, "[Files]" );
    FileWrite( piffile, concat( "Application=", concat(strip(wrkdrv),"\", strip(proj), "\", strip(expor)), "\", strip(expor), strip(appext(2)) ) );
    FileWrite(piffile, concat("InputData=", concat(strip(findir),"\","ECUM2012.DAT")));
    FileWrite( piffile, concat( "Listing=",concat(strip(wrkdrv),"\", strip(proj), "\", strip(expor),"\", strip(expor), ".lst" )));
   
   
   { User files section }
    FileWrite( piffile, " " );
    FileWrite( piffile, "[UserFiles]" );
    FileWrite( piffile, concat( "EPC2012ITN=", concat(strip(wrkdrv),"\","ECUM2012ITN","\","SPSS","\","ECUM2012ITN.DAT")));
    FileWrite( piffile, concat( "EPC2012IND=", concat(strip(wrkdrv),"\","ECUM2012IND","\","SPSS","\","ECUM2012IND.DAT")));
    FileWrite( piffile, concat( "EPC2012MEN=", concat(strip(wrkdrv),"\","ECUM2012MEN","\","SPSS","\","ECUM2012MEN.DAT")));
   { Parameters section }
    FileWrite( piffile, " " );
    FileWrite( piffile, "[Parameters]" );
    FileWrite( piffile, "ViewListing=Always" );
    FileWrite( piffile, "ViewResults=Yes" );
    FileWrite( piffile, "ListingWidth=80" );
    FileWrite( piffile, "MessageWrap=No" );
    FileWrite( piffile, "ErrmsgOverride=No" );
    close( piffile );
  end;

  function runpff1( apptype );
    { Using single quotes instead of double quotes as double quotes are needed in the string generated }
    ExecSystem( concat('"', strip(cspro), '\', strip(appx(2)), '.exe" ',
                            strip(wrkdrv),"\", strip(proj), "\",strip(expor), "\",strip(expor), '.pff'), wait );
  end;

  function op_SPSS ( );
   if Fileconcat(concat(strip(findir),"\","ECUM2012.DAT"), concat(strip(findir),"\","S???.DAT")) then
     gen_EXPORT ( ); 
     runpff1( Batch);
     errmsg(" Executez les pour transferer les fichiers au format .DAT au format .SAV ");
   else
     errmsg(" Warning : vrifiez s'il y a dj des fichiers  l'tape finale ");
   endif;
  end;

  
  { ---------------------------------------------------------------------------- }

  { ued by function Backup to copy from diretory xdir to directory bkpdest }
  function xcop( typef );
    fname = concat( fcodes[typef:1], "*.dat" );      { main/verified data files }
    FileCopy( concat(strip(xdir), "\", fname),
              concat(bkpdrv, "\", strip(proj), "\", strip(bkpdest) ) );
    { backup others for main data files only }
    if typef = main then
      fname = concat( fcodes[typef+2:1], "*.dat" );  { other data files for main }
      FileCopy( concat(strip(xdir), "\", fname),
                concat(bkpdrv, "\", strip(proj), "\", strip(bkpdest) ) );
    endif;
  end;

  { B: Backup daily }
  function op_BAK();
  {FR} errmsg( "... Sauvegarde de toutes les donnes sur %s\%s.\nVeuillez insrer le disque Zip dans le lecteur %s et ensuite effacer le message. ", {FR}
                bkpdrv, proj, bkpdrv );
    xdir = findir; bkpdest = "FINAL"; xcop( main );
    xdir = bkpdir; bkpdest = "DATA";  xcop( main );
    xdir = wrkdir; bkpdest = "WORK";  xcop( main );
    xdir = rawdir; bkpdest = "RAWD";  xcop( main );
    xdir = verdir; bkpdest = "VERI";  xcop( verif );
    { finally copy the control file }
    FileCopy( concat(strip(wrkprj), "\CONTROLE.DAT"),
              concat(strip(bkpdrv), "\", strip(proj), "\CONTROLE.DAT") );
  {FR} errmsg( "*** Opration de sauvegarde termine." ) {FR}
  end;


  { ---------------------------------------------------------------------------- }
  
PROC ENTRY_MENU_FF

preproc

  CSPro  ="C:\Program Files\CSPro 4.1";
  { Country code.  Change XX by the country where the application is used }
  cc = "";
  { Project directory (use 4 characters) }
  proj = "ECUM2012\MASQUE";
  { Application names }
  { try to use the suggested application names for standarization purposes }
  entapp   = "ECUM2012";       { application de saisie de donnes }
  ckid     = "AFFICHE";       { check ID application }
  editing  = "EDIT";          { application dition secondaire }
  centry   = "CENTRY";        { control file, data entry application CENTRY} 
  compar   = "COMPARER";      { application pour comparaison }
  statrep  = "STATREP";       { application status report }
  expor    = "EXPORT";        { application exportation donnees }
  { Dictionary name }
  dic = concat( cc, "ECUM2012" );
  { Floppy drive (in case of no network) }
  floppy = "F:";
  { File codes - S = saisie, V = Vrification, A = Autre, P = Autre (Verification) }
  fcodes  = "SVAP";
  appt(1) = "Entry";     appx(1) = "CSENTRY";     appext(1) = ".ENT";  Entry=1;
  appt(2) = "Batch";     appx(2) = "CSBATCH";     appext(2) = ".BCH";  Batch=2;
  appt(3) = "Compare";   appx(3) = "CSDIFF";      appext(3) = ".CMP";  Diff=3;
 
  Main    = 1;
  Verif   = 2;
  Others  = 3;
  msg     = 1;        { Whether to display message for missing file in chkexist }
  nomsg   = 0;        { ... or not to display the message }

  { Set work drives }
  wrkdrv = "C:";
  bkpdrv = "G:";
  wrkprj = concat( strip(wrkdrv), "\", proj );
  supdir = concat( strip(wrkprj), "\SUPERV" );
  repdir = concat( strip(wrkprj), "\REPORTS" );
  entdir = concat( strip(wrkprj), "\ENTRY" );
  dicdir = concat( strip(wrkprj), "\DICTS" );

  { Main and verification data will be in these directories }
  bkpdir = concat( strip(wrkprj), "\DATA" );
  wrkdir = concat( strip(wrkprj), "\WORK" );
  verdir = concat( strip(wrkprj), "\VERI" );
  rawdir = concat( strip(wrkprj), "\RAWD" );
  findir = concat( strip(wrkprj), "\FINAL" );

  { The following directories are assumed }
  { \EPC2012ANW                      Repertoire courant enquete (some files located here) }
  { \EPC2012ANW \MASQUE\SUPERV       Repertoire du superviseur                          }
  { \EPC2012ANW \MASQUE\ENTRY        Repertoire pour programme de saisie de donnes     }
  { \EPC2012ANW \MASQUE\DICTS        Repertoire pour dictionnaires                      }
  { \EPC2012ANW \MASQUE\WORK         Repertoire pour stocker les versions courantes des fichiers }
  { \EPC2012ANW \MASQUE\DATA         Repertoire pour stocker donnes sauvegardes  partir des postes de saisie }
  { \EPC2012ANW \MASQUE\RAWD         Repertoire pour sauvegarder les donnes }
  { \EPC2012ANW \MASQUE\FINAL        Repertoire pour stocker les donnes finales }
  { \EPC2012ANW \MASQUE\VERI         Repertoire pour stocker les donnes de verification }
  { \EPC2012ANW \MASQUE\REPORTS      Repertoire pour stocker les listings }
  { \EPC2012ANW \MASQUE\DOCS         Repertoire pour stocker les manuels et les documents de l'enqute }

  { Check that all directories needed exist }
  xdir = wrkprj; chkdir();
  xdir = supdir; chkdir();
  xdir = entdir; chkdir();
  xdir = dicdir; chkdir();
  xdir = bkpdir; chkdir();
  xdir = wrkdir; chkdir();
  xdir = rawdir; chkdir();
  xdir = findir; chkdir();
  xdir = verdir; chkdir();
  xdir = repdir; chkdir();

  { Check that there are not two concurrent sessions of CSPro loaded at the same time }
  SetFile( justone, concat( strip(supdir), "\justone.txt" ) );
  if FileExist( justone ) = 1 then
    FileRead( justone, cmdline );
    errmsg( "*** %s", strip(cmdline) );
    if accept(
  {FR}       "Re-initialiser","Oui","Non" {FR}
             ) = 1 then
      FileDelete( justone )
    else
      stop(-1);
    endif;
  endif;

  FileWrite( justone,
  {FR} "Il y a une autre session en cours ou bien que l'ordinateur s'est plant en cours d'excution" {FR}
           );
  close( justone );

  { ---------------------------------------------------------------------------- }
PROC ECLUSTER
xcluster = edit("999",$);
  if !loadcase( CONTROLE, ECLUSTER ) then
  {FR} errmsg( "*** Grappe numro %s non trouve ", {FR}
                xcluster );
   { reenter;}
  endif;
  always = 1;
  while always do   { loop forever }
    wdir = wrkdir;
    { Get the selected option }
  {FR}
    choice = accept("Options du menu du superviseur ECUM2012 ",
                    "C  Fichier de contrle des grappes........................C",   {1}
                    "A  Accepter la grappe.....................................A",   {2}
                    "L  Liste des questionnaires dans le fichier de donnes....L",   {3}
                    "-----------------------------------------------------------",   {4}
                    "V  Vrification des questionnaires doublement introduits..V",   {5}
                    "K  Sauvegarder le fichier initial de donnes brutes.......K",   {6}
                    "-----------------------------------------------------------",   {7}
                    "G  Gnrer une liste d'erreurs............................G",   {8}
                    "M  Modifier le fichier de donnes.........................M",   {9}
                    "S  Sauvegarder le fichier final de donnes dites........S",   {10}
                    "-----------------------------------------------------------",   {11}
                    "T  Transfert des DONNEES de la cl USB  l'ordinateur...T",     {12}
                    "U  Transfert VERIFICATION de la cl USB  l'ordinateur..U",     {13}
                    "-----------------------------------------------------------",   {14}
                    "R  Rapport de l'etat de traitement de donnes.............R",   {15}
                    "F  Exporter donnees vers SPSS ............................F",   {16}
                    "B  Sauvegarde quotidienne.................................B",   {17}
                    "-----------------------------------------------------------",   {18}
                    "N  Nouveau numro de grappe...............................N",   {19}
                    "Q  Quitter................................................Q");  {21}
  {FR}
        if choice =  0 then reenter; { quitter menu & allouer saisie nouveau numero grappe/ZD }
    elseif choice =  1 then op_QCT();             { manipuler fichier de controle }
    elseif choice =  2 then op_ACC();             { accepter une grappe/ZD }
    elseif choice =  3 then op_LST();             { lister questionnaires d'une grappe/ZD }
    elseif choice =  4 then { do nothing }
    elseif choice =  5 then op_VER();             { verifier questionnaires doublement saisies }
    elseif choice =  6 then op_KEE();             { sauvegarde donnees originales avant edition }
    elseif choice =  7 then { do nothing }
    elseif choice =  8 then op_GEN();             { executer edition secondaire }
    elseif choice =  9 then op_MOD();             { modifier donnes apres edition secondaire }
    elseif choice = 10 then op_SAV();             { sauvegarde donnees apres edition secondaire }
    elseif choice = 11 then { do nothing }
    elseif choice = 12 then Transfer(1);          { transferer fichier principal donnees }
    elseif choice = 13 then Transfer(2);          { transferer fichier de donnes en verification }
    elseif choice = 14 then { do nothing }
    elseif choice = 15 then op_CST();             { produire le rapport sur l'volution de la saisie  }
    elseif choice = 16 then op_SPSS();            { executer l'exportation des donnees }
    elseif choice = 17 then op_BAK();             { faire une sauvegarde de donnes }
    elseif choice = 18 then { do nothing }
    elseif choice = 19 then reenter;              { obtenir un nouveau numro de grappe }
    elseif choice = 20 then                       { quitter le menu }
      if FileExist( justone ) then
        FileDelete( justone )
      endif;
      stop(-1);       { quit the process }
    endif;
  enddo;
